#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "../include/protocol.h"

char *smtp_cmd[] =
{
  "MAIL FROM:", "RCPT TO:", "VRFY", "EXPN", "HELO", "SEND FROM:",
  "SOML FROM:", "SAML FROM:", "HELP", NULL
};

int smtp_setup(void)
{
  char host[256];
  unsigned int port;

  port = DEFAULT_SMTP_PORT;
  memset(host, '\0', sizeof (host));
  memcpy(host, DEFAULT_HOST, strlen(DEFAULT_HOST));

  while (1)
  {
    _clean();
    _header("SMTP Configuration");
    if(strlen(host) != 0)
      printf("<1> Hostname: %s\n", host);
    else
      printf("<1> Hostname:\n");
    if(port > 0)
      printf("<2> Port....: %d\n", port);
    else
      printf("<2> Port....:\n");
    _footer();
    printf("[E] Execute\n");
    printf("[M] Back [Main Menu]\n");
    printf("[B] Back [Protocol Selection]\n");
    printf("[Q] Quit\n");
    printf("\nSelect> ");

    switch (_input())
    {
      case '1': printf("Hostname: ");
                scanf("%255s", host);
                break;
      case '2': printf("Port    : ");
                scanf("%u", &port);
                break;
      case 'E':
      case 'e': smtp_start(host, port);
                break;
      case 'M':
      case 'm': main_menu();
      case 'B': 
      case 'b': return 0;
      case 'Q':
      case 'q': _leave();
      default : break;
    }
  }
  return -1;
}

int smtp_start(char *host, unsigned short port)
{
  int sock, rbytes, sbytes;
  char *cmd, *str;
  char buffer[DEFAULT_RESPONSE_SIZE];

  _clean();

  while (1)
  {
    if ((sock = handle_connect(host, port)) < 0)
      return -1;

    cmd = smtp_cmd[rand_int(0, MAX_INDEX(smtp_cmd))];
    str = rand_string();

    sbytes = ostrich_send(sock, "%s %s\r\n", cmd, str);
    if (sbytes == -1)
    {
      close(sock);
      _error("cant send to host!\n");
      return -2;
    }
    printf("%s|send:%6u|%s %s %.60s\n", COLOR_SEND, sbytes, NORMAL, cmd, str);

    rbytes = ostrich_recv(sock, buffer, sizeof (buffer) - 1);
    if (rbytes == -1)
    {
      close(sock);
      _error("can't recv from host!\n");
      return -3;
    }
    printf("%s|recv:%6u|%s %.60s\n", COLOR_RECV, rbytes, NORMAL, buffer);

    close(sock);
  }

  return -4;
}
